#exec Texture Import File=..\Bobodinga\Textures\Bobo_HUD\Bobo_HUD.dds Name=Bobohud GROUP=textures Mips=On FLAGS=1

class BoboHud extends HudBase
    config(User);

var() Font LevelActionFontFont;
var() Color LevelActionFontColor;
var() float LevelActionPositionX, LevelActionPositionY;


var() SpriteWidget NumNotesBG;
var int num_notes;
var Controller CurrentPC;

function PostRender(canvas C)
{
    Super.PostRender(C);
    if (!bHideHUD) {
        num_notes = BoboPlayerController( CurrentPC ).NumNotes;
        if (num_notes > 0)
        {
            DrawSpriteWidget( C, NumNotesBG );
        	C.SetPos(C.ClipX * 0.05,C.ClipY / 23);               // how do I fucking align text to a center point?
            C.DrawColor.R = 130;
            C.DrawColor.G = 185;
            C.DrawColor.B = 255;
            C.Font = GetMediumFontFor(C);
            if (num_notes < 70)
            {
                C.DrawText(num_notes, False );
            } else
            {
                C.DrawText("all 70", False );
            }
        }
    }
}

function PostBeginPlay()
{
	local Controller C;

	Super.PostBeginPlay();
    for (C = Level.ControllerList; C != None; C = C.NextController)
        if (PlayerController(C) != None)
            CurrentPC = PlayerController(C);

}

//-----------------------------overriding message() in order to force color changes for dialog ... whew ...
simulated function Message( PlayerReplicationInfo PRI, coerce string Msg, name MsgType )
{
	local Class<LocalMessage> LocalMessageClass;

	switch( MsgType )
	{
		case 'Say':
			if ( PRI == None )
				return;
			Msg = PRI.PlayerName$": "$Msg;
			LocalMessageClass = class'SayMessagePlus';
			break;
		case 'TeamSay':
			if ( PRI == None )
				return;
			Msg = PRI.PlayerName$"("$PRI.GetLocationName()$"): "$Msg;
			LocalMessageClass = class'TeamSayMessagePlus';
			break;
		case 'CriticalEvent':
			LocalMessageClass = class'CriticalEventPlus';
			LocalizedMessage( LocalMessageClass, 0, None, None, None, Msg );
			return;
		case 'DeathMessage':
			LocalMessageClass = class'xDeathMessage';
			break;
		case 'ObiSay':
			LocalMessageClass = class'ObiMessage';
			LocalizedMessage( LocalMessageClass, 0, None, None, None, Msg );
			return;
		case 'LukeSay':
			LocalMessageClass = class'LukeMessage';
			LocalizedMessage( LocalMessageClass, 0, None, None, None, Msg );
			return;
		default:
			LocalMessageClass = class'StringMessagePlus';
			break;
	}

	AddTextMessage(Msg,LocalMessageClass,PRI);
}

// function CheckCountdown(GameReplicationInfo GRI)     //OK I need to override whatever interacts with this fucker ...Level.TimeSeconds?

function bool DrawLevelAction (Canvas C)
{
    local String LevelActionText;
    local Plane OldModulate;

    if ((Level.LevelAction == LEVACT_None) && (Level.Pauser != none))
    {
        LevelActionText = LevelActionPaused;
    }
    else if ((Level.LevelAction == LEVACT_Loading) || (Level.LevelAction == LEVACT_Precaching))
        LevelActionText = LevelActionLoading;
    else
        LevelActionText = "";

    if (LevelActionText == "")
        return (false);

    C.Font = LoadLevelActionFont();
    C.DrawColor = LevelActionFontColor;
    C.Style = ERenderStyle.STY_Alpha;

    OldModulate = C.ColorModulate;
    C.ColorModulate = C.default.ColorModulate;
    C.DrawScreenText (LevelActionText, LevelActionPositionX, LevelActionPositionY, DP_MiddleMiddle);
    C.ColorModulate = OldModulate;

    return (true);
}

simulated function font LoadLevelActionFont()
{
	if( LevelActionFontFont == None )
	{
		LevelActionFontFont = Font(DynamicLoadObject(LevelActionFontName, class'Font'));
		if( LevelActionFontFont == None )
			Log("Warning: "$Self$" Couldn't dynamically load font "$LevelActionFontName);
	}
	return LevelActionFontFont;
}

defaultproperties
{
    NumNotesBG=(WidgetTexture=Texture'Bobohud',PosX=0.0,PosY=0.0,OffsetX=6,OffsetY=6,DrawPivot=DP_UpperLeft,RenderStyle=STY_Alpha,TextureCoords=(X1=0,Y1=0,X2=127,Y2=255),TextureScale=0.50,ScaleMode=SM_Right,Scale=1.000000,Tints[0]=(G=255,R=255,B=255,A=255),Tints[1]=(G=255,R=255,B=255,A=255))

	LevelActionFontColor=(R=255,G=255,B=255,A=255)
	LevelActionPositionX=0.500000
	LevelActionPositionY=0.250000

	ConsoleMessagePosX=0.005000
	ConsoleMessagePosY=0.87
}
