class KeyController extends Actor placeable;

//-----------------------------------------------------------------------------
//  This is the home of the functions for getting the various objects moving
//  and for testing their states for solving the final puzzle.
//-----------------------------------------------------------------------------

//for some fuckin reason the following line seems to make zero difference ...
//#exec Texture Import File=Textures\UEd_Icons\KeyController.pcx Name=S_TerrainInfo Mips=Off MASKED=1

var bool bSphereEnabled;
var bool bTowerEnabled;
var bool bWallEnabled;
var bool bSphereState;
var bool bBigSphereState;
var bool bTowerState;
var bool bBigTowerState;
var bool bWallState;
var bool bMapHack;      // for some reason bHidden has become unreliable for map signs ... using this to fix ... EL HACKO

var mover SignWallBlank;
var mover SignWallActive;
var mover SignTowerBlank;
var mover SignTowerActive;
var mover SignSphereBlank;
var mover SignSphereActive;
var mover SignMapBlank;
var mover SignMapActive;
var mover SignMapSuccess;
var mover SignExitLocked;
var mover SignExitOpen;
var mover SignHint1;
var mover SignHint2;

//---------------------find dynamic sign objects and assign variable references, for access later
function PostBeginPlay()
{
    local Mover CurrentSign;

    foreach AllActors(class'Mover', CurrentSign)
    {
        if (CurrentSign.Tag == 'sign_wall_blank')               // replace with switch statement
            SignWallBlank = CurrentSign;
        else if (CurrentSign.Tag == 'sign_wall_active')
            SignWallActive = CurrentSign;
        else if (CurrentSign.Tag == 'sign_sphere_blank')
            SignSphereBlank = CurrentSign;
        else if (CurrentSign.Tag == 'sign_sphere_active')
            SignSphereActive = CurrentSign;
        else if (CurrentSign.Tag == 'sign_tower_blank')
            SignTowerBlank = CurrentSign;
        else if (CurrentSign.Tag == 'sign_tower_active')
            SignTowerActive = CurrentSign;
        else if (CurrentSign.Tag == 'sign_map_blank')
            SignMapBlank = CurrentSign;
        else if (CurrentSign.Tag == 'sign_map_active')
            SignMapActive = CurrentSign;
        else if (CurrentSign.Tag == 'sign_map_success')
            SignMapSuccess = CurrentSign;
        else if (CurrentSign.Tag == 'sign_exit_locked')
            SignExitLocked = CurrentSign;
        else if (CurrentSign.Tag == 'sign_exit_open')
            SignExitOpen = CurrentSign;
        else if (CurrentSign.Tag == 'sign_hint1')
            SignHint1 = CurrentSign;
        else if (CurrentSign.Tag == 'sign_hint2')
            SignHint2 = CurrentSign;
    }
    // in case restarting level, actually this is probably not needed, my problem lies elsewhere.
    bSphereEnabled=false;
    bTowerEnabled=false;
    bWallEnabled=false;
    bSphereState=false;
    bBigSphereState=false;
    bTowerState=false;
    bBigTowerState=false;
    bWallState=false;
    bMapHack=false;
}


//--------------------------------------------------------enables sign rotations & swaps when triggered
simulated function Trigger ( actor Other, pawn EventInstigator )
{
    if (Other.Tag == 'SphereTrigger')
    {
        bSphereEnabled=true;
//      EventInstigator.ClientMessage("Spheres Enabled!");
//------swap sign objects ... animating textures might be better for performance ... feh no time
        SignSphereBlank.bHidden=true;
        SignSphereActive.bHidden=false;
    }
    else if (Other.Tag == 'TowerTrigger')
    {
        bTowerEnabled=true;
        SignTowerBlank.bHidden=true;
        SignTowerActive.bHidden=false;
    }
    else if (Other.Tag == 'WallTrigger')
    {
        bWallEnabled=true;
        SignWallBlank.bHidden=true;
        SignWallActive.bHidden=false;
    }
    else if (Other.Tag == 'MapFXTrigger')
    {
        if (SignMapSuccess.bHidden)
        {
            if (bMapHack == true)
            {
                SignMapActive.bHidden=true;
                SignMapBlank.bHidden=false;
                bMapHack=false;
            }
            else
            {
                SignMapActive.bHidden=false;
                SignMapBlank.bHidden=true;
                bMapHack=true;
            }
        }
    }
    else if (Other.Tag == 'FinalMapFXTrigger')
    {
        SignMapBlank.bHidden = true;
     	SignMapActive.bHidden = true;
     	SignMapSuccess.bHidden = false;
     	SignExitLocked.bHidden = true;
     	SignExitOpen.bHidden = false;
    }
    else if (Other.IsA('BoboPlayerController'))
    {
        SignHint1.bHidden = true;
        SignHint2.bHidden = false;
    }
    else
    {
        EventInstigator.ClientMessage("Bad Trigger");
    }
}

//-------------------------------------called from KeypressInteraction.uc
function UpdateState ( name ThisMover )
{
    switch ( ThisMover )
    {
        case 'Sphere':
            bSphereState=ToggleBool( bSphereState );
            break;
        case 'BigSphere':
            bBigSphereState=ToggleBool( bBigSphereState );
            break;
        case 'Wall':
            bWallState=ToggleBool( bWallState );
            break;
        case 'Tower':
            bTowerState=ToggleBool( bTowerState );
            break;
        case 'BigTower':
            bBigTowerState=ToggleBool( bBigTowerState );
            break;
    }
}

function bool ToggleBool ( bool CurrentState )
{
    if (CurrentState==false)
        return true;
    else
        return false;
}

//---------------------------------------called from MapTrigger.uc
function bool CheckPuzzle ()
{
    local Mover ThisMover;

    foreach AllObjects(class'Mover', ThisMover)
    {
        if (ThisMover.bInterpolating)
            return false;
    }
//---------------------debug/
//    log("bSphereState="@bSphereState@"bBigSphereState="@bBigSphereState@"bTowerState="@bTowerState);
//    log("bBigTowerState="@bBigTowerState@"bWallState="@bWallState);
//---------------------/debug
    if (bSphereState==true && bBigSphereState==false && bTowerState==false && bBigTowerState==true && bWallState == true)
    {
        return true;
    }
}


defaultproperties
{
    bSphereEnabled=false
    bTowerEnabled=false
    bWallEnabled=false
    bSphereState=false
    bBigSphereState=false
    bTowerState=false
    bBigTowerState=false
    bWallState=false
    bMapHack=false
    Tag=KeyController
    DrawScale=4.000000
}
