Class KeypressInteraction extends Interaction;

var keycontroller TheKeyController;

//---------------------find key controller actor and assign to class variable, for access later
function Initialize()           // interestingly, postbeginplay does not work here ...
{
    local KeyController ThisKeyController;

    // would be nice to compress this and all AllCalls with MatchTag parameter, then don't need Tag check!
    foreach AllObjects(class'KeyController', ThisKeyController)
    {
        if (ThisKeyController.Tag == 'KeyController')
        {
              TheKeyController = ThisKeyController;
        }
    }
    ViewportOwner.Actor.ClientMessage("The Key Controller is" @TheKeyController);
}

event NotifyLevelChange()       // to prevent multiple copies of interaction!
{
        Master.RemoveInteraction(self);
}

function bool KeyEvent(EInputKey Key, EInputAction Action, FLOAT Delta )
{
    local Mover ThisMover;

//    ViewportOwner.Actor.ClientMessage("currentp=" @TheKeyController.bSphereEnabled);

    if ((Action == IST_Press) && (Key == IK_LeftMouse))
    {
        if (TheKeyController != none && TheKeyController.bSphereEnabled == true)
            TheKeyController.UpdateState( 'Sphere' );
        foreach AllObjects(class'Mover', ThisMover)
        {
            if (ThisMover.Tag == 'Sphere')
            {
                if (TheKeyController != None && TheKeyController.bSphereEnabled == true)
                {
                    ThisMover.Trigger( None, None );
                }
            }
            if (ThisMover.Tag == 'BigSphere')
            {
                if (TheKeyController != None && TheKeyController.bSphereEnabled == true)
                {
                    if (!ThisMover.bInterpolating)
                    {
                        ThisMover.Trigger( None, None );
                        TheKeyController.UpdateState( ThisMover.Tag );   // Danger!  only works if there is ONE BigSphere
                    }
                }
            }
        }
    }
    if ((Action == IST_Press) && (Key == IK_RightMouse))
    {
        if (TheKeyController != none && TheKeyController.bWallEnabled == true)
            TheKeyController.UpdateState( 'Wall' );
        foreach AllObjects(class'Mover', ThisMover)
        {
            if (ThisMover.Tag == 'Wall')
            {
                if (TheKeyController != None && TheKeyController.bWallEnabled == true)
                {
                    ThisMover.Trigger( None, None );
                }
            }
        }
    }
    if ((Action == IST_Press) && (Key == IK_MiddleMouse))
    {
        if (TheKeyController != none && TheKeyController.bTowerEnabled == true)
            TheKeyController.UpdateState( 'Tower' );
        foreach AllObjects(class'Mover', ThisMover)
        {
            if (ThisMover.Tag == 'Tower' || ThisMover.Tag == 'Tower_a' || ThisMover.Tag == 'Tower_b' )     // added separate Tower_* object so that safety fences could have distinct bases
            {
                if (TheKeyController != None && TheKeyController.bTowerEnabled == true)
                {
                    ThisMover.Trigger( None, None );
                }
            }
            if (ThisMover.Tag == 'BigTower')
            {
                if (TheKeyController != None && TheKeyController.bTowerEnabled == true)
                {
                    if (!ThisMover.bInterpolating)
                    {
                        ThisMover.Trigger( None, None );
                        TheKeyController.UpdateState( ThisMover.Tag );
                    }
                }
            }
        }
        return true;    // this prevents default middlemouse keybinding (walk fwd) from kicking in, praise be.
    }
/*---------------------------------------------------------This makes forward-slash enable all movers ... for debug
    if ((Action == IST_Press) && (Key == IK_Slash))
    {
        if (TheKeyController != none)
        {
            TheKeyController.bSphereEnabled = true;
            TheKeyController.bTowerEnabled = true;
            TheKeyController.bWallEnabled = true;
        }
        ViewportOwner.Actor.ClientMessage("all movers enabled");
        return true;
    } 
-------------------------------------------------------------*/
    return false;
}

DefaultProperties
{
    bActive=True
}
