class MapTrigger extends Trigger placeable;

var keycontroller TheKeyController;
var mover MapPlatform;

var bool bBigDoorOpen;


//---------------------find key controller and bigdoor and assign to class variable, for access later
function PostBeginPlay()
{
    local KeyController ThisKeyController;
    local Mover ThisMover;

    foreach AllActors(class'KeyController', ThisKeyController)
    {
        if (ThisKeyController.Tag == 'KeyController')
              TheKeyController = ThisKeyController;
    }
    foreach AllActors(class'Mover', ThisMover)
    {
        if (ThisMover.Tag == 'map_platform')
            MapPlatform = ThisMover;
    }
}


function Trigger( actor Other, pawn EventInstigator )
{
    super.Trigger( Other, EventInstigator );

    if (!bBigDoorOpen)
    {
        if (TheKeyController.CheckPuzzle() == true) //---------------if you get map puzzle right:
        {
            TriggerEvent('door_unlocked', self, none);   // triggers final map sign fx, unlocking cutscene, and sets condition to prevent locked-door cutscene
            bBigDoorOpen = true;
            MapPlatform.Tag = 'disconnected';       // stops platform from being triggered
        }
    }
}


defaultproperties
{
    bBigDoorOpen=false
    Tag=check_puzzle
    DrawScale=2.000000
}
